Package net.sf.saxon.type

## Class AnyFunctionType

- java.lang.Object
- - net.sf.saxon.type.AnyFunctionType

- All Implemented Interfaces:
    `FunctionItemType`, `ItemType`
  Direct Known Subclasses:
    `AnyFunctionTypeWithAssertions`, `ArrayItemType`, `MapType`, `SpecificFunctionType`, `TupleItemType`

      public class AnyFunctionType
      extends java.lang.Object
      implements FunctionItemType

  An ItemType representing the type function(*). Subtypes represent function items with more specific type signatures.

  Note that although this class has a singleton instance representing the type `function(*)`, there are also likely to be instances of subclasses representing more specific function types.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static AnyFunctionType` | `ANY_FUNCTION` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AnyFunctionType()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AnnotationList` | `getAnnotationAssertions()` | Get the list of annotation assertions defined on this function item type.
    `SequenceType[]` | `getArgumentTypes()` | Get the argument types of the function
    `PlainType` | `getAtomizedItemType()` | Get the item type of the atomic values that will be produced when an item of this type is atomized
    `java.lang.String` | `getBasicAlphaCode()` | Get an alphabetic code representing the type, or at any rate, the nearest built-in type from which this type is derived.
    `double` | `getDefaultPriority()` | Get the default priority when this ItemType is used as an XSLT pattern
    `static AnyFunctionType` | `getInstance()` | Get the singular instance of this type (Note however that subtypes of this type may have any number of instances)
    `ItemType` | `getPrimitiveItemType()` | Get the primitive item type corresponding to this item type.
    `int` | `getPrimitiveType()` | Get the primitive type corresponding to this item type.
    `SequenceType` | `getResultType()` | Get the result type
    `UType` | `getUType()` | Get the corresponding `UType`.
    `boolean` | `isArrayType()` | Ask whether this function item type is an array type.
    `boolean` | `isAtomicType()` | Determine whether this item type is an atomic type
    `boolean` | `isAtomizable​(TypeHierarchy th)` | Ask whether values of this type are atomizable
    `boolean` | `isMapType()` | Ask whether this function item type is a map type.
    `boolean` | `isPlainType()` | Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
    `Expression` | `makeFunctionSequenceCoercer​(Expression exp, RoleDiagnostic role)` | Create an expression whose effect is to apply function coercion to coerce a function from this type to another type
    `boolean` | `matches​(Item item, TypeHierarchy th)` | Test whether a given item conforms to this type
    `Affinity` | `relationship​(FunctionItemType other, TypeHierarchy th)` | Determine the relationship of one function item type to another
    `java.lang.String` | `toString()` | Produce a representation of this type name for use in error messages.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.FunctionItemType

      `getGenre`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `explainMismatch, getFullAlphaCode, getNormalizedDefaultPriority, isTrueItemType, toExportString`

- - ### Field Detail

    - #### ANY_FUNCTION

          public static final AnyFunctionType ANY_FUNCTION

  - ### Constructor Detail

    - #### AnyFunctionType

          public AnyFunctionType()

  - ### Method Detail

    - #### getInstance

          public static AnyFunctionType getInstance()

      Get the singular instance of this type (Note however that subtypes of this type may have any number of instances)
      Returns:
        the singular instance of this type

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Specified by:
        `getUType` in interface `ItemType`
      Returns:
        the smallest UType that subsumes this item type

    - #### isAtomicType

          public boolean isAtomicType()

      Determine whether this item type is an atomic type
      Specified by:
        `isAtomicType` in interface `ItemType`
      Returns:
        true if this is ANY_ATOMIC_TYPE or a subtype thereof

    - #### isPlainType

          public boolean isPlainType()

      Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
      Specified by:
        `isPlainType` in interface `ItemType`
      Returns:
        true if this is ANY_ATOMIC_TYPE or a subtype thereof

    - #### isMapType

          public boolean isMapType()

      Ask whether this function item type is a map type. In this case function coercion (to the map type) will never succeed.
      Specified by:
        `isMapType` in interface `FunctionItemType`
      Returns:
        true if this FunctionItemType is a map type

    - #### isArrayType

          public boolean isArrayType()

      Ask whether this function item type is an array type. In this case function coercion (to the array type) will never succeed.
      Specified by:
        `isArrayType` in interface `FunctionItemType`
      Returns:
        true if this FunctionItemType is an array type

    - #### getDefaultPriority

          public double getDefaultPriority()

      Get the default priority when this ItemType is used as an XSLT pattern
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Returns:
        the default priority

    - #### getBasicAlphaCode

          public java.lang.String getBasicAlphaCode()

      Get an alphabetic code representing the type, or at any rate, the nearest built-in type from which this type is derived. The codes are designed so that for any two built-in types A and B, alphaCode(A) is a prefix of alphaCode(B) if and only if A is a supertype of B.
      Specified by:
        `getBasicAlphaCode` in interface `ItemType`
      Returns:
        the alphacode for the nearest containing built-in type

    - #### getArgumentTypes

          public SequenceType[] getArgumentTypes()

      Get the argument types of the function
      Specified by:
        `getArgumentTypes` in interface `FunctionItemType`
      Returns:
        the argument types, as an array of SequenceTypes, or null if this is the generic function type function(*)

    - #### getAnnotationAssertions

          public AnnotationList getAnnotationAssertions()

      Get the list of annotation assertions defined on this function item type.
      Specified by:
        `getAnnotationAssertions` in interface `FunctionItemType`
      Returns:
        the list of annotation assertions, or an empty list if there are none

    - #### matches

          public boolean matches​(Item item,
                                 TypeHierarchy th)
                          throws XPathException

      Test whether a given item conforms to this type
      Specified by:
        `matches` in interface `ItemType`
      Parameters:
        `item` - The item to be tested
        `th` -
      Returns:
        true if the item is an instance of this type; false otherwise
      Throws:
        `XPathException`

    - #### getPrimitiveItemType

          public final ItemType getPrimitiveItemType()

      Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that integer, xs:dayTimeDuration, and xs:yearMonthDuration are considered to be primitive types. For function items it is the singular instance FunctionItemType.getInstance().
      Specified by:
        `getPrimitiveItemType` in interface `ItemType`
      Returns:
        the corresponding primitive type

    - #### getPrimitiveType

          public final int getPrimitiveType()

      Get the primitive type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Returns:
        the integer fingerprint of the corresponding primitive type

    - #### toString

          public java.lang.String toString()

      Produce a representation of this type name for use in error messages.
      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of the type, in notation resembling but not necessarily identical to XPath syntax

    - #### getAtomizedItemType

          public PlainType getAtomizedItemType()

      Get the item type of the atomic values that will be produced when an item of this type is atomized
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Returns:
        the item type of the atomic values that will be produced when an item of this type is atomized

    - #### isAtomizable

          public boolean isAtomizable​(TypeHierarchy th)

      Ask whether values of this type are atomizable
      Specified by:
        `isAtomizable` in interface `ItemType`
      Parameters:
        `th` - The type hierarchy cache
      Returns:
        true if some or all instances of this type can be successfully atomized; false * if no instances of this type can be atomized

    - #### relationship

          public Affinity relationship​(FunctionItemType other,
                                       TypeHierarchy th)

      Determine the relationship of one function item type to another
      Specified by:
        `relationship` in interface `FunctionItemType`
      Returns:
        for example `Affinity.SUBSUMES`, `Affinity.SAME_TYPE`

    - #### makeFunctionSequenceCoercer

          public Expression makeFunctionSequenceCoercer​(Expression exp,
                                                        RoleDiagnostic role)
                                                 throws XPathException

      Create an expression whose effect is to apply function coercion to coerce a function from this type to another type
      Specified by:
        `makeFunctionSequenceCoercer` in interface `FunctionItemType`
      Parameters:
        `exp` - the expression that delivers the supplied sequence of function items (the ones in need of coercion)
        `role` - information for use in diagnostics
      Returns:
        the sequence of coerced functions, each on a function that calls the corresponding original function after checking the parameters
      Throws:
        `XPathException`

    - #### getResultType

          public SequenceType getResultType()

      Get the result type
      Specified by:
        `getResultType` in interface `FunctionItemType`
      Returns:
        the result type